﻿using System;
using System.Collections.Generic;

namespace StrategyFindSmallest
{
    public class FindSmallest<T>
    {
        private Comparison<T> _comparisonStrategy;

        public Comparison<T> ComparisonStrategy
        {
            get { return _comparisonStrategy; }
            set
            {
                if (value == null)
                {
                    throw new ArgumentNullException("ComparisonStrategy");
                }
                _comparisonStrategy = value;
            }
        }

        public FindSmallest(Comparison<T> comparisonStrategy)
        {
            if (comparisonStrategy == null)
            {
                throw new ArgumentNullException("comparisonStrategy");
            }
            ComparisonStrategy = comparisonStrategy;
        }

        public T DoIt(IEnumerable<T> elements)
        {
            T smallestSoFar = default(T);
            bool first = true;
            foreach (T element in elements)
            {
                if (first)
                {
                    smallestSoFar = element;
                    first = false;
                }
                else if (ComparisonStrategy.Invoke(smallestSoFar, element) > 0)
                {
                    smallestSoFar = element;
                }
            }
            return smallestSoFar;
        }
    }
}
