﻿using System;
using System.Collections.Generic;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using StrategyFindSmallest;

namespace StrategyFindSmallestTests
{
    [TestClass]
    public class FindSmallestTests
    {
        [TestMethod]
        public void DoItTest()
        {
            FindSmallest<String> findSmallest = new FindSmallest<String>(
                (s1, s2) => s1.Length - s2.Length);
            string[] elements = {"Anders", "John", "Bo"};
            String smallest = findSmallest.DoIt(elements);
            Assert.AreEqual("Bo", smallest);

            findSmallest.ComparisonStrategy = (s1, s2) => s1.CompareTo(s2);
            smallest = findSmallest.DoIt(elements);
            Assert.AreEqual("Anders", smallest);

            IList<String> emptyList = new List<string>();
            Assert.IsNull(findSmallest.DoIt(emptyList));

            try
            {
                new FindSmallest<int>(null);
                Assert.Fail();
            }
            catch (ArgumentNullException) { /* empty */ }

            try
            {
                findSmallest.ComparisonStrategy = null;             
                Assert.Fail();
            }
            catch (ArgumentNullException) { /* empty */ }
        }
    }
}
